<template>
  <div class="installation">
    <!-- <h1>Installation</h1>
    <p>is standalone mode: {{isStandAloneMode}}</p>
    <pre>{{uuid}}</pre>
    <pre>{{did}}</pre>
    <pre>status {{status}}</pre>

    <p>User ends up here after he/she clicked the link in the email</p> -->
    <h1 class="app-header">Please add this app to your homescreen</h1>
  </div>
</template>

<script>
import { mapGetters } from 'vuex';
import isStandAloneMode from '../../utils/standalone';
import { MARK_AS_OPENED, MARK_AS_INSTALLED, basePath } from './actions';

export default {
  name: 'installation',
  props: ['uuidFromRouter', 'didFromRouter', 'urlFromRouter'],
  methods: {
    handleInstallation() {
      console.log('triggered after user adds to homescreen');
      this.$store.dispatch(basePath(MARK_AS_INSTALLED));
    },
    handleBeforeInstallation() {
      console.log('triggered before install promp, you can customize here');
      this.handleInstallation();
    },
  },
  data: () => ({ isStandAloneMode: isStandAloneMode() }),

  computed: {
    ...mapGetters('Installation', ['uuid', 'status', 'url', 'did']),
  },

  created() {
    this.$store.dispatch(basePath(MARK_AS_OPENED), {
      did: this.didFromRouter,
      uuid: this.uuidFromRouter,
      url: this.urlFromRouter,
    });

    window.addEventListener('beforeinstallprompt', this.handleBeforeInstallation);
    window.addEventListener('appinstalled', this.handleInstallation);
  },

  destroyed() {
    window.removeEventListener('appinstalled', this.handleInstallation);
    window.removeEventListener('beforeinstallprompt', this.handleBeforeInstallation);
  },
};
</script>
